Index: /palm/trunk/SOURCE/init_dvrp.f90
===================================================================
--- /palm/trunk/SOURCE/init_dvrp.f90	(revision 1319)
+++ /palm/trunk/SOURCE/init_dvrp.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -28,38 +34,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 284 2009-04-06 06:36:10Z raasch
-! Definition of a colortable to be used for particles.
-! Output names are changed: surface=groundplate, buildings=topography
-! Output of messages replaced by message handling routine.
-! Clipping implemented.
-! Polygon reduction for building and ground plate isosurface. Reduction level
-! for buildings can be chosen with parameter cluster_size.
-! Steering, splitting, and rtsp routines not used on nec.
-! ToDo: checking of mode_dvrp for legal values is not correct
-! Implementation of a MPI-1 coupling: __mpi2 adjustments for MPI_COMM_WORLD
-!
-! 210 2008-11-06 08:54:02Z raasch
-! DVRP arguments changed to single precision, mode pathlines added
-!
-! 155 2008-03-28 10:56:30Z letzel
-! introduce prefix_chr to ensure unique dvrp_file path
-!
-! 130 2007-11-13 14:08:40Z letzel
-! allow two instead of one digit to specify isosurface and slicer variables
-! Test output of isosurface on camera file
-!
-! 82 2007-04-16 15:40:52Z raasch
-! Preprocessor strings for different linux clusters changed to "lc",
-! routine local_flush is used for buffer flushing
-!
-! 17 2007-02-19 01:57:39Z raasch
-! dvrp_output_local activated for all streams
-!
-! 13 2007-02-14 12:15:07Z raasch
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.12  2006/02/23 12:30:22  raasch
-! ebene renamed section, pl.. replaced by do..,
 !
 ! Revision 1.1  2000/04/27 06:24:39  raasch
@@ -73,30 +45,82 @@
 #if defined( __dvrp_graphics )
 
-    USE arrays_3d
+    USE arrays_3d,                                                             &
+        ONLY:  zu
+        
     USE DVRP
+    
     USE dvrp_variables
-    USE grid_variables
-    USE indices
+    
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+        
+    USE indices,                                                               &
+        ONLY:  nx, nxl, nxr, ny, nyn, nys, nzb, nzb_s_inner
+        
+    USE kinds
+    
     USE pegrid
-    USE control_parameters
+    
+    USE control_parameters,                                                               &
+        ONLY:  message_string, nz_do3d, run_identifier, topography
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=2)  ::  section_chr
-    CHARACTER (LEN=3)  ::  prefix_chr
-    CHARACTER (LEN=80) ::  dvrp_file_local
-    INTEGER ::  cluster_mode, cluster_size_x, cluster_size_y, cluster_size_z, &
-                gradient_normals, i, j, k, l, m, nx_dvrp_l, nx_dvrp_r,        &
-                ny_dvrp_n, ny_dvrp_s, pn, tv, vn
-    LOGICAL ::  allocated
-    REAL(4) ::  center(3), cluster_alpha, distance, tmp_b, tmp_g, tmp_r, &
-                tmp_t, tmp_th, tmp_thr, tmp_x1, tmp_x2, tmp_y1, tmp_y2,  &
-                tmp_z1, tmp_z2, tmp_1, tmp_2, tmp_3, tmp_4, tmp_5, tmp_6, tmp_7
-
-    REAL(4), DIMENSION(:,:,:), ALLOCATABLE ::  local_pf
-
-    TYPE(CSTRING), SAVE ::  dvrp_directory_c, dvrp_file_c, &
-                            dvrp_file_local_c,dvrp_host_c, &
-                            dvrp_password_c, dvrp_username_c, name_c
+    CHARACTER (LEN=2)  ::  section_chr      !:
+    CHARACTER (LEN=3)  ::  prefix_chr       !:
+    CHARACTER (LEN=80) ::  dvrp_file_local  !:
+    
+    INTEGER(iwp) ::  cluster_mode      !:
+    INTEGER(iwp) ::  cluster_size_x    !:
+    INTEGER(iwp) ::  cluster_size_y    !:
+    INTEGER(iwp) ::  cluster_size_z    !:
+    INTEGER(iwp) ::  gradient_normals  !:
+    INTEGER(iwp) ::  i                 !:
+    INTEGER(iwp) ::  j                 !:
+    INTEGER(iwp) ::  k                 !:
+    INTEGER(iwp) ::  l                 !:
+    INTEGER(iwp) ::  m                 !:
+    INTEGER(iwp) ::  nx_dvrp_l         !:
+    INTEGER(iwp) ::  nx_dvrp_r         !:
+    INTEGER(iwp) ::  ny_dvrp_n         !:
+    INTEGER(iwp) ::  ny_dvrp_s         !:
+    INTEGER(iwp) ::  pn                !:
+    INTEGER(iwp) ::  tv                !:
+    INTEGER(iwp) ::  vn                !:
+                     
+    LOGICAL  ::  allocated  !:
+    
+    REAL(sp) ::  center(3)      !:
+    REAL(sp) ::  cluster_alpha  !:
+    REAL(sp) ::  distance       !:
+    REAL(sp) ::  tmp_b          !:
+    REAL(sp) ::  tmp_g          !:
+    REAL(sp) ::  tmp_r          !:
+    REAL(sp) ::  tmp_t          !:
+    REAL(sp) ::  tmp_th         !:
+    REAL(sp) ::  tmp_thr        !:
+    REAL(sp) ::  tmp_x1         !:
+    REAL(sp) ::  tmp_x2         !:
+    REAL(sp) ::  tmp_y1         !:
+    REAL(sp) ::  tmp_y2         !:
+    REAL(sp) ::  tmp_z1         !:
+    REAL(sp) ::  tmp_z2         !:
+    REAL(sp) ::  tmp_1          !:
+    REAL(sp) ::  tmp_2          !:
+    REAL(sp) ::  tmp_3          !:
+    REAL(sp) ::  tmp_4          !:
+    REAL(sp) ::  tmp_5          !:
+    REAL(sp) ::  tmp_6          !:
+    REAL(sp) ::  tmp_7          !:
+
+    REAL(sp), DIMENSION(:,:,:), ALLOCATABLE ::  local_pf  !:
+
+    TYPE(CSTRING), SAVE ::  dvrp_directory_c   !:
+    TYPE(CSTRING), SAVE ::  dvrp_file_c        !:
+    TYPE(CSTRING), SAVE ::  dvrp_file_local_c  !:
+    TYPE(CSTRING), SAVE ::  dvrp_host_c        !:
+    TYPE(CSTRING), SAVE ::  dvrp_password_c    !:
+    TYPE(CSTRING), SAVE ::  dvrp_username_c    !:
+    TYPE(CSTRING), SAVE ::  name_c             !:
 
 !
@@ -718,12 +742,16 @@
 #if defined( __dvrp_graphics )
 
-    USE control_parameters
-    USE dvrp_variables
+    USE dvrp_variables,                                                        &
+        ONLY:  use_seperate_pe_for_dvrp_output
+    
+    USE kinds
+    
     USE pegrid
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=4) ::  chr
-    INTEGER           ::  idummy
+    CHARACTER (LEN=4) ::  chr  !:
+    
+    INTEGER(iwp) ::  idummy    !:
 
 !
@@ -778,10 +806,13 @@
 !------------------------------------------------------------------------------!
 #if defined( __dvrp_graphics )
-
-    USE control_parameters
-    USE dvrp
-    USE dvrp_variables
-
-    INTEGER ::  m
+                                               
+    USE DVRP
+    
+    USE dvrp_variables,                                                        &
+        ONLY: use_seperate_pe_for_dvrp_output
+    
+    USE kinds
+
+    INTEGER(iwp) ::  m  !:
 
 !
Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 1319)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -81,59 +87,4 @@
 ! New cpp directive "__check" implemented which is used by check_namelist_files
 !
-! 759 2011-09-15 13:58:31Z raasch
-! Splitting of parallel I/O in blocks of PEs
-!
-! 722 2011-04-11 06:21:09Z raasch
-! Bugfix: bc_lr/ns_cyc replaced by bc_lr/ns, because variables are not yet set
-!         here
-!
-! 709 2011-03-30 09:31:40Z raasch
-! formatting adjustments
-!
-! 707 2011-03-29 11:39:40Z raasch
-! bc_lr/ns replaced by bc_lr/ns_cyc
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Definition of new array bounds nxlg, nxrg, nysg, nyng on each PE. 
-! Furthermore the allocation of arrays and steering of loops is done with these
-! parameters. Call of exchange_horiz are modified.
-! In case of dirichlet bounday condition at the bottom zu(0)=0.0
-! dzu_mg has to be set explicitly for a equally spaced grid near bottom.
-! ddzu_pres added to use a equally spaced grid near bottom.
-!
-! 555 2010-09-07 07:32:53Z raasch
-! Bugfix: default setting of nzb_local for flat topography
-!
-! 274 2009-03-26 15:11:21Z heinze
-! Output of messages replaced by message handling routine.
-! new topography case 'single_street_canyon'
-!
-! 217 2008-12-09 18:00:48Z letzel
-! +topography_grid_convention
-!
-! 134 2007-11-21 07:28:38Z letzel
-! Redefine initial nzb_local as the actual total size of topography (later the 
-! extent of topography in nzb_local is reduced by 1dx at the E topography walls 
-! and by 1dy at the N topography walls to form the basis for nzb_s_inner); 
-! for consistency redefine 'single_building' case.
-! Calculation of wall flag arrays
-!
-! 94 2007-06-01 15:25:22Z raasch
-! Grid definition for ocean version
-!
-! 75 2007-03-22 09:54:05Z raasch
-! storage of topography height arrays zu_s_inner and zw_s_inner,
-! 2nd+3rd argument removed from exchange horiz
-!
-! 19 2007-02-23 04:53:48Z raasch
-! Setting of nzt_diff
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.17  2006/08/22 14:00:05  raasch
-! +dz_max to limit vertical stretching,
-! bugfix in index array initialization for line- or point-like topography
-! structures
-!
 ! Revision 1.1  1997/08/11 06:17:45  raasch
 ! Initial revision (Testversion)
@@ -145,27 +96,93 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  dd2zu, ddzu, ddzu_pres, ddzw, dzu, dzu_mg, dzw, dzw_mg, f1_mg,  &
+               f2_mg, f3_mg, l_grid, l_wall, zu, zw
+        
+    USE control_parameters,                                                             &
+        ONLY:  bc_lr, bc_ns, building_height, building_length_x,               &
+               building_length_y, building_wall_left, building_wall_south,     &
+               canyon_height, canyon_wall_left, canyon_wall_south,             &
+               canyon_width_x, canyon_width_y, coupling_char, dp_level_ind_b,  &
+               dz, dz_max, dz_stretch_factor, dz_stretch_level,                &
+               dz_stretch_level_index, ibc_uv_b, io_blocks, io_group,          &
+               inflow_l, inflow_n, inflow_r, inflow_s, masking_method,         &
+               maximum_grid_level, message_string, momentum_advec, ocean,      &
+               outflow_l, outflow_n, outflow_r, outflow_s, prandtl_layer,      &
+               psolver, scalar_advec, topography, topography_grid_convention,  &
+               use_surface_fluxes, use_top_fluxes, wall_adjustment_factor 
+        
+    USE grid_variables,                                                        &
+        ONLY:  ddx, ddx2, ddx2_mg, ddy, ddy2, ddy2_mg, dx, dx2, dy, dy2, fwxm, &
+               fwxp, fwym, fwyp, fxm, fxp, fym, fyp, wall_e_x, wall_e_y,       &
+               wall_u, wall_v, wall_w_x, wall_w_y, zu_s_inner, zw_w_inner
+        
+    USE indices,                                                               &
+        ONLY:  flags, nbgp, nx, nxl, nxlg, nxlu, nxl_mg, nxr, nxrg, nxr_mg,    &
+               ny, nyn, nyng, nyn_mg, nys, nysv, nys_mg, nysg, nz, nzb,        &
+               nzb_2d, nzb_diff, nzb_diff_s_inner, nzb_diff_s_outer,           &
+               nzb_diff_u, nzb_diff_v, nzb_max, nzb_s_inner, nzb_s_outer,      &
+               nzb_u_inner, nzb_u_outer, nzb_v_inner, nzb_v_outer,             &
+               nzb_w_inner, nzb_w_outer, nzt, nzt_diff, nzt_mg, rflags_invers, &
+               rflags_s_inner, wall_flags_0, wall_flags_00, wall_flags_1,      &
+               wall_flags_10, wall_flags_2, wall_flags_3,  wall_flags_4,       &
+               wall_flags_5, wall_flags_6, wall_flags_7, wall_flags_8,         &
+               wall_flags_9
+    
+    USE kinds
+    
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER ::  bh, blx, bly, bxl, bxr, byn, bys, ch, cwx, cwy, cxl, cxr, cyn, &
-                cys, gls, i, ii, inc, j, k, l, nxl_l, nxr_l, nyn_l, nys_l,     &
-                nzb_si, nzt_l, vi
-
-    INTEGER, DIMENSION(:), ALLOCATABLE   ::  vertical_influence
-
-    INTEGER, DIMENSION(:,:), ALLOCATABLE ::  corner_nl, corner_nr, corner_sl,  &
-                                             corner_sr, wall_l, wall_n, wall_r,&
-                                             wall_s, nzb_local, nzb_tmp
-
-    LOGICAL :: flag_set = .FALSE.
-
-    REAL    ::  dx_l, dy_l, dz_stretched
-
-    REAL, DIMENSION(:,:), ALLOCATABLE   ::  topo_height
+    INTEGER(iwp) ::  bh      !:
+    INTEGER(iwp) ::  blx     !:
+    INTEGER(iwp) ::  bly     !:
+    INTEGER(iwp) ::  bxl     !:
+    INTEGER(iwp) ::  bxr     !:
+    INTEGER(iwp) ::  byn     !:
+    INTEGER(iwp) ::  bys     !:
+    INTEGER(iwp) ::  ch      !:
+    INTEGER(iwp) ::  cwx     !:
+    INTEGER(iwp) ::  cwy     !:
+    INTEGER(iwp) ::  cxl     !:
+    INTEGER(iwp) ::  cxr     !:
+    INTEGER(iwp) ::  cyn     !:
+    INTEGER(iwp) ::  cys     !:
+    INTEGER(iwp) ::  gls     !:
+    INTEGER(iwp) ::  i       !:
+    INTEGER(iwp) ::  ii      !:
+    INTEGER(iwp) ::  inc     !:
+    INTEGER(iwp) ::  j       !:
+    INTEGER(iwp) ::  k       !:
+    INTEGER(iwp) ::  l       !:
+    INTEGER(iwp) ::  nxl_l   !:
+    INTEGER(iwp) ::  nxr_l   !:
+    INTEGER(iwp) ::  nyn_l   !:
+    INTEGER(iwp) ::  nys_l   !:
+    INTEGER(iwp) ::  nzb_si  !:
+    INTEGER(iwp) ::  nzt_l   !:
+    INTEGER(iwp) ::  vi      !:
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE   ::  vertical_influence  !:
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  corner_nl  !:
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  corner_nr  !:
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  corner_sl  !:
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  corner_sr  !:
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  wall_l     !:
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  wall_n     !:
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  wall_r     !:
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  wall_s     !:
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_local  !:
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_tmp    !:
+
+    LOGICAL :: flag_set = .FALSE.  !:
+
+    REAL(wp) ::  dx_l          !:
+    REAL(wp) ::  dy_l          !:
+    REAL(wp) ::  dz_stretched  !:
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  topo_height  !:
 
     
Index: /palm/trunk/SOURCE/init_masks.f90
===================================================================
--- /palm/trunk/SOURCE/init_masks.f90	(revision 1319)
+++ /palm/trunk/SOURCE/init_masks.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -50,23 +55,4 @@
 ! 807 2012-01-25 11:53:51Z maronga
 ! New cpp directive "__check" implemented which is used by check_namelist_files
-!
-! 771 2011-10-27 10:56:21Z heinze
-! +lpt
-!
-! 595 2010-11-12 09:52:10Z helmke
-! Calculation of z locations for masked output changed
-!
-! 564 2010-09-30 13:18:59Z helmke
-! assignment of mask_xyz_loop added, palm message identifiers of masked output
-! changed 
-!/localdata/raasch.14299
-! 557 2010-09-07 14:50:07Z weinreis 
-! bugfix message string in set_mask_locations
-!
-! 553 2010-09-01 14:09:06Z weinreis
-! parameters for masked output are replaced by arrays
-!
-! 493 2010-03-01 08:30:24Z raasch
-! netcdf_format_mask* and format_parallel_io replaced by netcdf_data_format
 !
 ! 410 2009-12-04 17:05:40Z letzel
@@ -79,22 +65,54 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
-    USE netcdf_control
-    USE particle_attributes
+    USE arrays_3d,                                                             &
+        ONLY:  zu, zw
+
+    USE control_parameters,                                                    &
+        ONLY:  constant_diffusion, cloud_droplets, cloud_physics,              &
+               data_output_masks, data_output_masks_user,                      &
+               doav, doav_n, domask, domask_no, dz, dz_stretch_level, humidity,&
+               mask, masks, mask_scale, mask_i,                                &
+               mask_i_global, mask_j, mask_j_global, mask_k, mask_k_global,    &
+               mask_loop, mask_size, mask_size_l, mask_start_l, mask_x,        &
+               mask_x_loop, mask_xyz_dimension, mask_y, mask_y_loop, mask_z,   &
+               mask_z_loop, max_masks,  message_string, mid,                   &
+               netcdf_data_format, passive_scalar, ocean
+
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+
+    USE indices,                                                               &
+        ONLY:  nx, nxl, nxr, ny, nyn, nys, nz, nzb, nzt
+
+    USE kinds
+
+    USE netcdf_control,                                                        &
+        ONLY:  domask_unit
+
+    USE particle_attributes,                                                   &
+        ONLY:  particle_advection
+
     USE pegrid
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=6)   ::  var
-    CHARACTER (LEN=7)   ::  unit
-    CHARACTER (LEN=10), DIMENSION(max_masks,100) ::  do_mask, do_mask_user
-
-    INTEGER :: i, ilen, ind(6), ind_array(1), j, k, n, sender
-    INTEGER, DIMENSION(:), ALLOCATABLE ::  tmp_array
-
-    LOGICAL ::  found
+    CHARACTER (LEN=6) ::  var  !:
+    CHARACTER (LEN=7) ::  unit !:
+    
+    CHARACTER (LEN=10), DIMENSION(max_masks,100) ::  do_mask      !:
+    CHARACTER (LEN=10), DIMENSION(max_masks,100) ::  do_mask_user !:
+
+    INTEGER(iwp) ::  i            !: 
+    INTEGER(iwp) ::  ilen         !:
+    INTEGER(iwp) ::  ind(6)       !:
+    INTEGER(iwp) ::  ind_array(1) !:
+    INTEGER(iwp) ::  j            !:
+    INTEGER(iwp) ::  k            !:
+    INTEGER(iwp) ::  n            !:
+    INTEGER(iwp) ::  sender       !:
+    
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  tmp_array !:
+
+    LOGICAL ::  found !:
 !
 !-- Allocation and initialization
@@ -480,8 +498,22 @@
        IMPLICIT NONE
 
-       CHARACTER (LEN=2) :: dxyz_string, nxyz_string
-       INTEGER  ::  count, count_l, dim, m, loop_begin, loop_end, loop_stride, &
-                    lb, nxyz, ub
-       REAL     ::  dxyz, ddxyz, tmp1, tmp2
+       CHARACTER (LEN=2) ::  dxyz_string !:
+       CHARACTER (LEN=2) ::  nxyz_string !:
+       
+       INTEGER(iwp)  ::  count       !:
+       INTEGER(iwp)  ::  count_l     !:
+       INTEGER(iwp)  ::  dim         !:
+       INTEGER(iwp)  ::  m           !:
+       INTEGER(iwp)  ::  loop_begin  !:
+       INTEGER(iwp)  ::  loop_end    !:
+       INTEGER(iwp)  ::  loop_stride !:
+       INTEGER(iwp)  ::  lb          !:
+       INTEGER(iwp)  ::  nxyz        !:
+       INTEGER(iwp)  ::  ub          !:
+       
+       REAL(wp)      ::  dxyz  !:
+       REAL(wp)      ::  ddxyz !:
+       REAL(wp)      ::  tmp1  !:
+       REAL(wp)      ::  tmp2  !:
 
        count = 0;  count_l = 0;  ddxyz = 1.0 / dxyz;  tmp1 = 0.0;  tmp2 = 0.0
Index: /palm/trunk/SOURCE/init_ocean.f90
===================================================================
--- /palm/trunk/SOURCE/init_ocean.f90	(revision 1319)
+++ /palm/trunk/SOURCE/init_ocean.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -32,11 +37,4 @@
 ! code put under GPL (PALM 3.9)
 !
-! 388 2009-09-23 09:40:33Z raasch
-! Bugfix: Initial profiles of hydrostatic pressure and density are calculated
-! iteratively. First calculation of hyp(0) changed.
-!
-! 124 2007-10-19 15:47:46Z raasch
-! Bugfix: Initial density rho is calculated
-!
 ! 97 2007-06-21 08:23:15Z raasch
 ! Initial revision
@@ -47,19 +45,33 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE eqn_state_seawater_mod
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  dzu, hyp, pt_init, ref_state, sa_init, zu, zw
+
+    USE control_parameters,                                                    &
+        ONLY:  g, prho_reference, rho_surface, rho_reference,                  &
+               surface_pressure, use_single_reference_value
+
+    USE eqn_state_seawater_mod,                                                &
+        ONLY:  eqn_state_seawater, eqn_state_seawater_func
+
+    USE indices,                                                               &
+        ONLY:  nzb, nzt
+
+    USE kinds
+
     USE pegrid
-    USE statistics
+
+    USE statistics,                                                            &
+        ONLY:  hom, statistic_regions
 
     IMPLICIT NONE
 
-    INTEGER ::  k, n
+    INTEGER(iwp) ::  k !:
+    INTEGER(iwp) ::  n !:
 
-    REAL    ::  sa_l, pt_l
+    REAL(wp)     ::  pt_l !:
+    REAL(wp)     ::  sa_l !:
 
-    REAL, DIMENSION(nzb:nzt+1) ::  rho_init
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  rho_init !:
 
     ALLOCATE( hyp(nzb:nzt+1) )
@@ -119,5 +131,5 @@
 
        prho_reference = prho_reference + dzu(k+1) * &
-                        eqn_state_seawater_func( 0.0, pt_l, sa_l )
+                        eqn_state_seawater_func( 0.0_wp, pt_l, sa_l )
 
     ENDDO
Index: /palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- /palm/trunk/SOURCE/init_pegrid.f90	(revision 1319)
+++ /palm/trunk/SOURCE/init_pegrid.f90	(revision 1320)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -69,87 +74,4 @@
 ! 807 2012-01-25 11:53:51Z maronga
 ! New cpp directive "__check" implemented which is used by check_namelist_files
-!
-! 780 2011-11-10 07:16:47Z raasch
-! Bugfix for rev 778: Misplaced error message moved to the rigth place
-!
-! 778 2011-11-07 14:18:25Z fricke
-! Calculation of subdomain_size now considers the number of ghost points.
-! Further coarsening on PE0 is now possible for multigrid solver if the 
-! collected field has more grid points than the subdomain of an PE.
-!
-! 759 2011-09-15 13:58:31Z raasch
-! calculation of number of io_blocks and the io_group to which the respective
-! PE belongs
-!
-! 755 2011-08-29 09:55:16Z witha
-! 2d-decomposition is default for lcflow (ForWind cluster in Oldenburg)
-!
-! 722 2011-04-11 06:21:09Z raasch
-! Bugfix: bc_lr/ns_cyc/dirrad/raddir replaced by bc_lr/ns, because variables
-!         are not yet set here; grid_level set to 0
-!
-! 709 2011-03-30 09:31:40Z raasch
-! formatting adjustments
-!
-! 707 2011-03-29 11:39:40Z raasch
-! bc_lr/ns replaced by bc_lr/ns_cyc/dirrad/raddir
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Moved determination of target_id's from init_coupling
-! Determination of parameters needed for coupling (coupling_topology, ngp_a, 
-! ngp_o) with different grid/processor-topology in ocean and atmosphere
-! Adaption of ngp_xy, ngp_y to a dynamic number of ghost points.
-! The maximum_grid_level changed from 1 to 0. 0 is the normal grid, 1 to 
-! maximum_grid_level the grids for multigrid, in which 0 and 1 are normal grids.
-! This distinction is due to reasons of data exchange and performance for the 
-! normal grid and grids in poismg.
-! The definition of MPI-Vectors adapted to a dynamic numer of ghost points.
-! New MPI-Vectors for data exchange between left and right boundaries added. 
-! This is due to reasons of performance (10% faster).
-!
-! 646 2010-12-15 13:03:52Z raasch
-! lctit is now using a 2d decomposition by default
-!
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
-!
-! 438 2010-02-01 04:32:43Z raasch
-! 2d-decomposition is default for Cray-XT machines
-!
-! 274 2009-03-26 15:11:21Z heinze
-! Output of messages replaced by message handling routine.
-!
-! 206 2008-10-13 14:59:11Z raasch
-! Implementation of a MPI-1 coupling: added __parallel within the __mpi2 part
-! 2d-decomposition is default on SGI-ICE systems
-!
-! 197 2008-09-16 15:29:03Z raasch
-! multigrid levels are limited by subdomains if mg_switch_to_pe0_level = -1,
-! nz is used instead nnz for calculating mg-levels
-! Collect on PE0 horizontal index bounds from all other PEs,
-! broadcast the id of the inflow PE (using the respective communicator)
-!
-! 114 2007-10-10 00:03:15Z raasch
-! Allocation of wall flag arrays for multigrid solver
-!
-! 108 2007-08-24 15:10:38Z letzel
-! Intercommunicator (comm_inter) and derived data type (type_xy) for
-! coupled model runs created, assign coupling_mode_remote,
-! indices nxlu and nysv are calculated (needed for non-cyclic boundary
-! conditions)
-!
-! 82 2007-04-16 15:40:52Z raasch
-! Cpp-directive lcmuk changed to intel_openmp_bug, setting of host on lcmuk by
-! cpp-directive removed
-!
-! 75 2007-03-22 09:54:05Z raasch
-! uxrp, vynp eliminated,
-! dirichlet/neumann changed to dirichlet/radiation, etc.,
-! poisfft_init is only called if fft-solver is switched on
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.28  2006/04/26 13:23:32  raasch
-! lcmuk does not understand the !$ comment so a cpp-directive is required
 !
 ! Revision 1.1  1997/07/24 11:15:09  raasch
@@ -164,27 +86,69 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE grid_variables
-    USE indices
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr, bc_ns, coupling_mode, coupling_topology, dt_dosp,        &
+               gathered_size, grid_level, grid_level_count, host, inflow_l,    &
+               inflow_n, inflow_r, inflow_s, io_blocks, io_group,              &  
+               maximum_grid_level, maximum_parallel_io_streams, message_string,&
+               mg_switch_to_pe0_level, momentum_advec, psolver, outflow_l,     &
+               outflow_n, outflow_r, outflow_s, recycling_width, scalar_advec, &
+               subdomain_size 
+
+    USE grid_variables,                                                        &
+        ONLY:  dx
+        
+    USE indices,                                                               &
+        ONLY:  mg_loc_ind, nbgp, nnx, nny, nnz, nx, nx_a, nx_o, nxl, nxl_mg,   &
+               nxlu, nxr, nxr_mg, ny, ny_a, ny_o, nyn, nyn_mg, nys, nys_mg,    &
+               nysv, nz, nzb, nzt, nzt_mg, wall_flags_1, wall_flags_2,         &
+               wall_flags_3, wall_flags_4, wall_flags_5, wall_flags_6,         &
+               wall_flags_7, wall_flags_8, wall_flags_9, wall_flags_10
+
+    USE kinds
+      
     USE pegrid
-    USE statistics
-    USE transpose_indices
-
-
+ 
+    USE transpose_indices,                                                     &
+        ONLY:  nxl_y, nxl_yd, nxl_z, nxr_y, nxr_yd, nxr_z, nyn_x, nyn_z, nys_x,&
+               nys_z, nzb_x, nzb_y, nzb_yd, nzt_x, nzt_yd, nzt_y
 
     IMPLICIT NONE
 
-    INTEGER ::  i, id_inflow_l, id_recycling_l, ind(5), j, k,                &
-                maximum_grid_level_l, mg_switch_to_pe0_level_l, mg_levels_x, &
-                mg_levels_y, mg_levels_z, nnx_y, nnx_z, nny_x, nny_z, nnz_x, &
-                nnz_y, numproc_sqr, nxl_l, nxr_l, nyn_l, nys_l,    &
-                nzb_l, nzt_l, omp_get_num_threads
-
-    INTEGER, DIMENSION(:), ALLOCATABLE ::  ind_all, nxlf, nxrf, nynf, nysf
-
-    INTEGER, DIMENSION(2) :: pdims_remote
+    INTEGER(iwp) ::  i                        !:
+    INTEGER(iwp) ::  id_inflow_l              !:
+    INTEGER(iwp) ::  id_recycling_l           !:
+    INTEGER(iwp) ::  ind(5)                   !:
+    INTEGER(iwp) ::  j                        !:
+    INTEGER(iwp) ::  k                        !:
+    INTEGER(iwp) ::  maximum_grid_level_l     !:
+    INTEGER(iwp) ::  mg_levels_x              !:
+    INTEGER(iwp) ::  mg_levels_y              !:
+    INTEGER(iwp) ::  mg_levels_z              !:
+    INTEGER(iwp) ::  mg_switch_to_pe0_level_l !:
+    INTEGER(iwp) ::  nnx_y                    !:
+    INTEGER(iwp) ::  nnx_z                    !:
+    INTEGER(iwp) ::  nny_x                    !:
+    INTEGER(iwp) ::  nny_z                    !:
+    INTEGER(iwp) ::  nnz_x                    !:
+    INTEGER(iwp) ::  nnz_y                    !:
+    INTEGER(iwp) ::  numproc_sqr              !:
+    INTEGER(iwp) ::  nxl_l                    !:
+    INTEGER(iwp) ::  nxr_l                    !:
+    INTEGER(iwp) ::  nyn_l                    !:
+    INTEGER(iwp) ::  nys_l                    !:
+    INTEGER(iwp) ::  nzb_l                    !:
+    INTEGER(iwp) ::  nzt_l                    !:
+    INTEGER(iwp) ::  omp_get_num_threads      !:
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ind_all !:
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nxlf    !:
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nxrf    !:
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nynf    !:
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nysf    !:
+
+    INTEGER(iwp), DIMENSION(2) :: pdims_remote          !:
 
 #if defined( __mpi2 )
-    LOGICAL ::  found
+    LOGICAL ::  found                                   !:
 #endif
 
